"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Context = exports.COMPONENTS_DIR = exports.PAGES_DIR = exports.UTILS_FILE_PATH = exports.CONSTANTS_FILE_PATH = exports.USE_DIR = exports.SOURCE_CODE_PATH_IMPORT = exports.SOURCE_CODE_PATH = void 0;
const path_1 = require("path");
const config_1 = require("./config");
const dependence_1 = require("./dependence");
exports.SOURCE_CODE_PATH = 'src';
exports.SOURCE_CODE_PATH_IMPORT = '@';
exports.USE_DIR = 'common/use';
exports.CONSTANTS_FILE_PATH = 'common/constants.js';
exports.UTILS_FILE_PATH = 'common/utils.js';
exports.PAGES_DIR = 'pages';
exports.COMPONENTS_DIR = 'components';
function handleImpPath(filePath) {
    return filePath.replace(/\.[jt]s/, '');
}
class Context {
    constructor(config) {
        this.config = {};
        this.config = config;
        this.dependence = new dependence_1.Dependence(config_1.defaultDependencies);
    }
    getConstantsFilePath() {
        return this.config.path?.constants || exports.CONSTANTS_FILE_PATH;
    }
    getConstantsFilePathImp() {
        return handleImpPath(`${exports.SOURCE_CODE_PATH_IMPORT}/${this.getConstantsFilePath()}`);
    }
    getUtilsFilePath() {
        return this.config.path?.utils || exports.UTILS_FILE_PATH;
    }
    getUtilsFilePathImp() {
        return handleImpPath(`${exports.SOURCE_CODE_PATH_IMPORT}/${this.getUtilsFilePath()}`);
    }
    getUseDir() {
        return this.config.path?.useDir || exports.USE_DIR;
    }
    getUseDirImp() {
        return `${exports.SOURCE_CODE_PATH_IMPORT}/${this.getUseDir()}`;
    }
    getUseDirAndFileName(fileName) {
        const useFile = fileName.split('.')[0];
        const userPathConfig = (this.config.path || {});
        if (userPathConfig[useFile]) {
            return {
                dir: (0, path_1.dirname)(userPathConfig[useFile]),
                fileName: (0, path_1.basename)(userPathConfig[useFile]),
            };
        }
        return {
            dir: this.getUseDir(),
            fileName,
        };
    }
    getUseTableImp() {
        if (this.config.path?.useTable) {
            return `${exports.SOURCE_CODE_PATH_IMPORT}/${this.config.path?.useTable}`;
        }
        return `${this.getUseDirImp()}/useTable`;
    }
    getUseFetchImp() {
        if (this.config.path?.useFetch) {
            return `${exports.SOURCE_CODE_PATH_IMPORT}/${this.config.path?.useFetch}`;
        }
        return `${this.getUseDirImp()}/useFetch`;
    }
    getUseModelImp() {
        if (this.config.path?.useModel) {
            return `${exports.SOURCE_CODE_PATH_IMPORT}/${this.config.path?.useModel}`;
        }
        return `${this.getUseDirImp()}/useModel`;
    }
    getUseModalImp() {
        if (this.config.path?.useModal) {
            return `${exports.SOURCE_CODE_PATH_IMPORT}/${this.config.path?.useModal}`;
        }
        return `${this.getUseDirImp()}/useModal`;
    }
    getPagesDir() {
        return this.config.path?.pagesDir || exports.PAGES_DIR;
    }
    getPagesDirImp() {
        return `${exports.SOURCE_CODE_PATH_IMPORT}/${this.getPagesDir()}`;
    }
    getComponentsDir() {
        return this.config.path?.componentsDir || exports.COMPONENTS_DIR;
    }
    getComponentsDirImp() {
        return `${exports.SOURCE_CODE_PATH_IMPORT}/${this.getComponentsDir()}`;
    }
}
exports.Context = Context;
