"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCommonJsCode = void 0;
// 跟 api-design fesjs 等强相关共享代码
const fs_extra_1 = require("fs-extra");
const path_1 = require("path");
function getUtilsCode(ctx, rootDir) {
    return {
        content: (0, fs_extra_1.readFileSync)((0, path_1.join)(rootDir, 'utils.js'), 'utf-8'),
        dir: (0, path_1.dirname)(ctx.getUtilsFilePath()),
        fileName: (0, path_1.basename)(ctx.getUtilsFilePath()),
    };
}
function getUseCode(ctx, rootDir) {
    const useDir = (0, path_1.join)(rootDir, 'use');
    const files = (0, fs_extra_1.readdirSync)(useDir);
    return files.map((file) => {
        return {
            content: (0, fs_extra_1.readFileSync)((0, path_1.join)(useDir, file), 'utf8'),
            ...ctx.getUseDirAndFileName(file),
        };
    });
}
function getCommonJsCode(ctx) {
    const rootDir = (0, path_1.join)(__dirname, '../../template/common');
    return getUseCode(ctx, rootDir).concat(getUtilsCode(ctx, rootDir));
}
exports.getCommonJsCode = getCommonJsCode;
