"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.genDescriptionsSnippet = void 0;
const toycode_core_1 = require("@qlin/toycode-core");
const constants_1 = require("../constants");
const shared_1 = require("./shared");
function genSetupCode() {
    return {
        importSources: [
            {
                imported: 'FDescriptions',
                type: toycode_core_1.ImportType.ImportSpecifier,
                source: '@fesjs/fes-design',
            },
            {
                imported: 'FDescriptionsItem',
                type: toycode_core_1.ImportType.ImportSpecifier,
                source: '@fesjs/fes-design',
            },
        ],
        content: '',
    };
}
function genDescriptionsItem(fields) {
    return fields
        .filter((field) => field.checked)
        .map((item) => {
        return {
            componentName: 'FDescriptionsItem',
            props: {
                label: item.title,
            },
            children: [
                `{{${constants_1.ROW_DATA_PROP_NAME}.${item.alias || item.name}}}`,
            ],
        };
    });
}
function genDescriptionsSnippet(fields, parentId) {
    fields = (0, shared_1.formatResData)(fields);
    return {
        setup: genSetupCode(),
        component: {
            parentId,
            componentName: 'FDescriptions',
            props: {
                column: 1,
            },
            children: genDescriptionsItem(fields),
        },
    };
}
exports.genDescriptionsSnippet = genDescriptionsSnippet;
