"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applySearchAction = void 0;
const utils_1 = require("../utils");
const toycode_core_1 = require("@qlin/toycode-core");
const shared_1 = require("./shared");
function applySearchAction(ctx, pageConfig, sfc) {
    const params = pageConfig.apiSchema.params;
    if (!params?.length)
        return sfc;
    if ((0, utils_1.isReactiveSearch)(params)) {
        sfc.setupCodes.push({
            importSources: [
                {
                    imported: 'watch',
                    type: toycode_core_1.ImportType.ImportSpecifier,
                    source: 'vue',
                },
            ],
            content: `
            watch(searchParams, () => {
                refresh(searchParams);
            });
            `,
        });
    }
    else {
        sfc.setupCodes.push({
            importSources: [
                {
                    imported: 'FButton',
                    type: toycode_core_1.ImportType.ImportSpecifier,
                    source: '@fesjs/fes-design',
                },
                {
                    imported: 'SearchOutlined',
                    type: toycode_core_1.ImportType.ImportSpecifier,
                    source: '@fesjs/fes-design/icon',
                },
            ],
            content: '',
        });
        const actionComponent = {
            componentName: 'FButton',
            props: {
                type: 'primary',
            },
            events: {
                click: 'refresh(searchParams)',
            },
            children: ['搜索'],
            slots: [
                {
                    name: 'icon',
                    component: {
                        componentName: 'SearchOutlined',
                    },
                },
            ],
        };
        (0, shared_1.insertActionInSearchForm)(sfc.children, actionComponent);
    }
    return sfc;
}
exports.applySearchAction = applySearchAction;
